#include "thing_model.h"
#include "unistd.h"
#include "zmalloc.h"

// 替换部分
char *product_key        = "KYKZFRJ5";
char *device_name        = "test";
char *secret             = "5406c99061ce173641e10e80be8640b1";
char *model_id           = "thing_model";
char *host               = "localhost";
int   port               = 1883;
int   reconnect_interval = 10;
int   reconnect_time     = 3;

// 属性设置
// 原生类型参数设置
int    val_i1     = 0;
int    val_i2     = 0;
char   val_s3[16] = "text";
double val_d4     = 23.7;
double val_d5     = 23.7;
char   val_s6[16] = "1629344092";

// 结构体类型参数设置
emqc_tm_object val_struct[] = {
    { .type = EMQC_TM_INT, .key = "aaaa", .val_i = 0 },
    { .type = EMQC_TM_INT, .key = "bbbb", .val_i = 0 },
    { .type = EMQC_TM_DOUBLE, .key = "cccc", .val_d = 0.0 },
    { .type = EMQC_TM_TERMINATOR, .key = "", .val_o = NULL }
};

// 数组类型参数设置
int *   val_arr_int[] = { &val_i1, &val_i2, NULL };
double *val_arr_dou[] = { &val_d4, &val_d5, NULL };
char *  val_arr_str[] = { val_s3, val_s6, NULL };

emqc_tm_object val_struct1[] = {
    { .type = EMQC_TM_INT, .key = "asdf", .val_i = 0 },
    { .type = EMQC_TM_INT, .key = "hjkl", .val_i = 0 },
    // 这里是作为结束符必须的
    { EMQC_TM_TERMINATOR, "", .val_o = NULL }
};

emqc_tm_object val_struct2[] = {
    { .type = EMQC_TM_INT, .key = "asdf", .val_i = 0 },
    { .type = EMQC_TM_INT, .key = "hjkl", .val_i = 0 },
    // 这里是作为结束符必须的
    { .type = EMQC_TM_TERMINATOR, .key = "", .val_o = NULL }
};

emqc_tm_object *val_arr_struct[] = {

    val_struct1, val_struct2,
    NULL // 这里是作为结束符必须的
};

// 最终要上报的数据全部配置到这里
emqc_tm_object property_array[] = {
    { .type = EMQC_TM_INT, .key = "property_a1", .val_i = 10 },
    { .type = EMQC_TM_DOUBLE, .key = "property_a2", .val_d = 10.10 },
    { .type = EMQC_TM_STR, .key = "property_a3", .val_s = val_s6 },
    { .type = EMQC_TM_STRUCT, .key = "property_b", .val_o = &val_struct },
    { .type = EMQC_TM_ARR_INT, .key = "property_c", .val_o = &val_arr_int },
    { .type = EMQC_TM_ARR_DOUBLE, .key = "property_d", .val_o = &val_arr_dou },
    { .type = EMQC_TM_ARR_STR, .key = "property_e", .val_o = &val_arr_str },
    { .type  = EMQC_TM_ARR_STRUCT,.key   = "property_f",.val_o = &val_arr_struct },
    // 这里是作为结束符必须的
    { .type = EMQC_TM_TERMINATOR, .key = "", .val_o = NULL },
};


// 事件参数
char  val_param01_s1[] = "param011";
char  val_param01_s2[] = "param012";
char  val_param01_s3[] = "param013";
char  val_param01_s4[] = "param014";
char  val_param01_s5[] = "param015";
char  val_param01_s6[] = "param016";
char  val_param01_s7[] = "param017";
char  val_param01_s8[] = "param018";
char  val_param01_s9[] = "param019";

char *param01[]        = { 

  val_param01_s1, val_param01_s2,
  val_param01_s3, val_param01_s4,
  val_param01_s5, val_param01_s6,
  val_param01_s7, val_param01_s8,
  val_param01_s9, NULL 
};

char *event_idents[] = {
    "events",
    NULL,
};

emqc_tm_object event_array[] = {
    { .type = EMQC_TM_ARR_STR, .key = "param01", .val_o = &param01 },
    { .type = EMQC_TM_TERMINATOR, .key = "", .val_o = NULL },
};

// 服务参数
char *service_idents[] = {
    "service01",
    NULL,
};
emqc_tm_object service_array[] = {
    { .type = EMQC_TM_INT, .key = "output_param", .val_i = 0 },
    { .type = EMQC_TM_TERMINATOR, .key = "", .val_o = NULL },
};

void property_post(emqc_tm *tm)
{
    char sfx[] = "property/post";
    char mtd[] = "thing.property.post";
    char topic[EMQC_TM_TOPIC_LEN];

    json_object *jso = emqc_tm_new_payload(mtd, NULL);
    int          i   = 0;
    do {
        if (property_array[i].type == EMQC_TM_TERMINATOR) {
            break;
        }
        emqc_tm_add_post_param(jso, &property_array[i], model_id);
    } while (++i);

    snprintf(topic, EMQC_TM_TOPIC_LEN, TM_FMT, product_key, device_name, sfx);
    log_info("#PUB: %s", topic);
    log_info("#PAYLOAD: %s", json_object_to_json_string(jso));
    emqc_tm_pub(tm, topic, json_object_to_json_string(jso));
    json_object_put(jso);
    return;
}

void event_post(emqc_tm *tm)
{
    char func_id[32];
    char sfx[64] = "event/%s/post";
    char topic[EMQC_TM_TOPIC_LEN];

    int i = 0;
    int j = 0;
    while (event_idents[i] != NULL) {
        snprintf(func_id, sizeof(func_id), "%s:%s", model_id, event_idents[i]);
        snprintf(sfx, sizeof(sfx), "event/%s/post", func_id);
        snprintf(topic, EMQC_TM_TOPIC_LEN, TM_FMT, product_key, device_name,
                 sfx);

        json_object *jso = emqc_tm_new_payload("thing.event.post", func_id);
        do {
            if (event_array[j].type == EMQC_TM_TERMINATOR) {
                break;
            }

            emqc_tm_add_event_param(jso, &event_array[j], true);
        } while (++j);

        log_info("#PUB: %s", topic);
        log_info("#PAYLOAD: %s", json_object_to_json_string(jso));
        emqc_tm_pub(tm, topic, json_object_to_json_string(jso));
        json_object_put(jso);
        i++;
        j++;
    }

    return;
}

void get_desire(emqc_tm *tm)
{
    const char *keys[] = { "double", "ini32", "text" };
    char        sfx[]  = "property/desired/get";
    char        topic[EMQC_TM_TOPIC_LEN];

    snprintf(topic, EMQC_TM_TOPIC_LEN, TM_FMT, product_key, device_name, sfx);
    log_info("#PUB: %s", topic);
    json_object *jso = emqc_tm_new_payload("thing.property.desired.get", NULL);
    emqc_tm_add_get_desired_param(jso, (const char **) keys, 3, model_id);
    emqc_tm_pub(tm, topic, json_object_to_json_string(jso));
    json_object_put(jso);

    return;
}

void clear_desire(emqc_tm *tm)
{
    char          topic[EMQC_TM_TOPIC_LEN];
    char          sfx[] = "property/desired/delete";
    del_des_param ddp[] = { { "WF", NULL }, { "Power", "1" } };

    snprintf(topic, EMQC_TM_TOPIC_LEN, TM_FMT, product_key, device_name, sfx);
    log_info("#PUB: %s", topic);
    json_object *jso =
        emqc_tm_new_payload("thing.property.desired.delete", NULL);
    emqc_tm_add_del_desired_param(jso, ddp, 2, NULL);
    emqc_tm_pub(tm, topic, json_object_to_json_string(jso));
    json_object_put(jso);
    return;
}

void *property_post_reply_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    if (obj) {
        switch (obj->type) {
            case TM_REP:;
                tm_reply *tr = obj->rep;
                log_info("#RECV: id: %s, code: %d, data: %s", tr->id, tr->code, tr->data);
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }
    return NULL;
}

void *property_set_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    char *ret = NULL;
    if (obj) {
        switch (obj->type) {
            case TM_REQ:;
                tm_request *tr = obj->req;
                log_info("#RECV: id: %s, version: %s, method: %s, params: %s", tr->id,
                         tr->version, tr->method, tr->params);
                // 设置操作
                json_object *jso_tmp = json_tokener_parse(tr->params);
                emqc_tm_property_set(jso_tmp, property_array, model_id);

                json_object *jso      = json_object_new_object();
                json_object *jso_data = json_object_new_object();
                json_object_object_add(jso, "id", json_object_new_string(tr->id));
                json_object_object_add(jso, "code", json_object_new_int(0));
                json_object_object_add(jso, "data", jso_data);
                ret = zstrdup(json_object_to_json_string(jso));
                json_object_put(jso);
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }

    return (void *) ret;
}

void *service_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    char *       ret     = NULL;
    if (obj) {
        switch (obj->type) {
            case TM_REQ:;
                tm_request *tr = obj->req;
                log_info("#RECV: id: %s, version: %s, method: %s, params: %s", tr->id,
                         tr->version, tr->method, tr->params);
                json_object *jso_tmp = json_tokener_parse(tr->params);
                json_object *jso_val = NULL;
                int          val     = 0;

                int i = 0;
                int j = 0;
                while (service_idents[i] != NULL) {
                    if (!strstr(tr->method, service_idents[i])) {
                        do {
                            if (service_array[j].type == EMQC_TM_TERMINATOR) {
                                break;
                            }

                        } while (++j);

                    } else {
                        json_object *jso      = json_object_new_object();
                        json_object *jso_data = json_object_new_object();
                        do {
                            if (service_array[j].type == EMQC_TM_TERMINATOR) {
                                break;
                            }

                            // 这里可以加具体的操作。
                            // 根据输入计算输出。
                            emqc_tm_add_service_param(jso_data, service_array[j].key,
                                                      &service_array[j]);
                        } while (++j);

                        json_object_object_add(jso, "id", json_object_new_string(tr->id));
                        json_object_object_add(jso, "code", json_object_new_int(0));
                        json_object_object_add(jso, "data", jso_data);
                        ret = zstrdup(json_object_to_json_string(jso));
                        json_object_put(jso);
                        break;
                    }
                    i++;
                    j++;
                }
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }
    return (void *) ret;
}

void *event_post_reply_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    if (obj) {
        switch (obj->type) {
            case TM_REP:;
                tm_reply *tr = obj->rep;
                log_info("#RECV: id: %s, code: %d, data: %s", tr->id, tr->code, tr->data);
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }
    return NULL;
}

void *desire_get_reply_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    if (obj) {
        switch (obj->type) {
            case TM_REP:;
                tm_reply *tr = obj->rep;
                log_info("#RECV: id: %s, code: %d, data: %s", tr->id, tr->code, tr->data);
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }
    return NULL;
}

void *desire_delete_reply_cb(void *payload)
{
    emqc_tm_trans_object *obj = (emqc_tm_trans_object*) payload;
    if (obj) {
        switch (obj->type) {
            case TM_REP:;
                tm_reply *tr = obj->rep;
                log_info("#RECV: id: %s, code: %d, data: %s", tr->id, tr->code, tr->data);
                break;
            case TM_RAW:
                log_info("#RECV: raw_data: %s", obj->raw);
                break;
            default:
                log_err("Error trans type.");
        }
    }
    return NULL;
}

int main()
{
    //创建 物模型具柄
    emqc_tm *tm = emqc_tm_new();

    emqc_set_device_name(tm->handle, device_name);
    emqc_set_product_key(tm->handle, product_key);
    emqc_set_secret(tm->handle, secret);
    emqc_set_reconnect(tm->handle, reconnect_interval, reconnect_time);

    // 设置回调处理
    emqc_tm_set_dft_cb(tm, TM_CB_PROPERTY_SET, property_set_cb);
    emqc_tm_set_dft_cb(tm, TM_CB_PROPERTY_POST_REPLY, property_post_reply_cb);
    emqc_tm_set_dft_cb(tm, TM_CB_SYN_ACTION_EXEC, service_cb);
    emqc_tm_set_dft_cb(tm, TM_CB_DESIRED_GET_REPLY, desire_get_reply_cb);
    emqc_tm_set_dft_cb(tm, TM_CB_DESIRED_DEL_REPLY, desire_delete_reply_cb);

    // emqc_tm_set_ctm_cb(tm, TM_CB_EVENT_POST_REPLY, event_post_reply_cb,
    // model_id, identifier);
    int i = 0;
    while (event_idents[i] != NULL) {
        emqc_tm_set_ctm_cb(tm, TM_CB_EVENT_POST_REPLY, event_post_reply_cb,
                           model_id, event_idents[i++]);
    }

    i = 0;
    while (event_idents[i] != NULL) {
        emqc_tm_set_ctm_cb(tm, TM_CB_ASYN_ACTION_EXEC, service_cb, model_id,
                           service_idents[i++]);
    }

    emqc_tm_init(tm, host, port);

    // 物模型连接建立
    emqc_tm_connect(tm);

    // 物模型接收数据
    emqc_tm_sub(tm);

    for (;;) {
        // property_post(tm);
        // event_post(tm);
        // get_desire(tm);
        // clear_desire(tm);
        sleep(5);
    }

    emqc_tm_destroy(tm);
}