#include <gtest/gtest.h>
#include <string>
using namespace std;

extern "C" {
#include <emqc_base.h>
}

emqc *handle = NULL;

TEST(emqc_base, emqc_alloc)
{
    ASSERT_TRUE(handle == NULL);
    handle = emqc_alloc();
    ASSERT_TRUE(handle != NULL);

    ASSERT_TRUE(handle->product_key == NULL);
    ASSERT_TRUE(handle->device_name == NULL);
    ASSERT_TRUE(handle->client == NULL);

    ASSERT_TRUE(handle->reconn_interval == 0);
    ASSERT_TRUE(handle->reconn_times == 0);
    ASSERT_TRUE(handle->conn_opts != NULL);
}

TEST(emqc_base, emqc_set_product_key)
{
    ASSERT_TRUE(handle != NULL);
    ASSERT_TRUE(handle->product_key == NULL);
    char comp[] = "asdfghjkl";
    emqc_set_product_key(handle, comp);
    ASSERT_STREQ(handle->product_key, comp);
    // char *comp_null = NULL;
    // emqc_set_product_key(handle, comp_null);
    // ASSERT_STREQ(handle->product_key, comp);
}

TEST(emqc_base, emqc_set_device_name)
{
    ASSERT_TRUE(handle != NULL);
    ASSERT_TRUE(handle->device_name == NULL);
    char comp[] = "asdfghjkl";
    emqc_set_device_name(handle, comp);
    ASSERT_STREQ(handle->device_name, comp);
}

TEST(emqc_base, emqc_set_reconnect)
{
    ASSERT_TRUE(handle != NULL);
    ASSERT_TRUE(handle->reconn_interval == 0);
    ASSERT_TRUE(handle->reconn_times == 0);
    emqc_set_reconnect(handle, 10, 20);
    ASSERT_TRUE(handle->reconn_interval == 10);
    ASSERT_TRUE(handle->reconn_times == 20);
}

TEST(emqc_base, emqc_destroy)
{
    ASSERT_TRUE(handle != NULL);
    emqc_destroy(handle);
    // ASSERT_TRUE(handle == NULL);
}